/******************************************************************************************************************************************************
 * Name         :   ScenarioCtlr.cls
 * Description  :   Controller for New Scenario lightning component. 
 * Author       :   Raghvendra Rathore
 * Created On   :   05/15/2017
******************************************************************************************************************************************************/
public with sharing class ScenarioCtlr {

    public static final String DOCUMENT_NAME = 'Scenario_Template';
    /*
        Method to initiate Scenario Wrapper object bind in NewScenario component attribute.
        Returns object of type ScenarioWrapper
    */
    @AuraEnabled
    public static ScenarioWrapper initScenario(string workSpaceId){
        try {
            SecurityUtil.checkRead(Workspace__c.SObjectType, new list<string>{'Workspace_Start_Date__c','Workspace_End_Date__c'}, false) ;
            Workspace__c workspace = [select id, Workspace_Start_Date__c, Workspace_End_Date__c from Workspace__c where id =: workSpaceId];
            
            ScenarioWrapper scenarioObj = new ScenarioWrapper(workspace.Workspace_Start_Date__c,workspace.Workspace_End_Date__c);
            return scenarioObj;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static String getOrgNamespace() 
    {
        return SalesIQGlobalConstants.NAME_SPACE;        
    }
    

    /************************************************************
        Method :  Get non overlay team option based on country
        Param  : country sfid
    *************************************************************/
    @AuraEnabled
    public static map<String,String> getTeamOptions(String countryId){
        try {
            map<String,String> options = new map<String,String>();

            SecurityUtil.checkRead(Team__c.SObjectType, new list<string>{'Name'}, false) ;
            //Type__c <>: SalesIQGlobalConstants.TEAM_TYPE_OVERLAY and
            for(Team__c team : [Select id, Name from Team__c where  Country__c  = :countryId order by Name])
            {
                options.put(team.Id,team.Name);
            }
            return options;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    /**************************************************************
    * Method : Get Affiliation Network, Geo Type based for a selected team instance
    * Param 1 : team instance sfid
    SIQ 1022  
    ***************************************************************/

    @AuraEnabled
    public static Team_Instance__c getExistingTeamInstanceAttributes(String teamInstanceId){
        try {
            return [SELECT Affiliation_Network__c, Affiliation_Network__r.Name , Geography_Type_Name__c, Geography_Type_Name__r.Name FROM Team_Instance__c WHERE Id =: teamInstanceId limit 1];
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    /**************************************************************
    * Method : Get Geo Types of a country
    * Param 1 : country sfid
    ***************************************************************/
    @AuraEnabled
    public static map<String,String> getGeoLayerOptions(String countryId){
        try {
            map<String,String> options = new map<String,String>();
            SecurityUtil.checkRead(Team__c.SObjectType, new list<string>{'Name'}, false) ;
            for(Geography_Type__c geo : [Select id, Name from Geography_Type__c where Country__c = :countryId order by Name])
            {
                options.put(geo.Id,geo.Name);
            }
            return options;
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    /**************************************************************
    * Method : Get Affiliation Network options of a country
    * Param 1 : country sfid
    ***************************************************************/
    @AuraEnabled
    public static Map<String,String> getAffiliationNetworkOptions(String countryId){
        try {
                Map<String,String> options = new Map<String,String>();
                SecurityUtil.checkRead(Affiliation_Network__c.SObjectType, new list<string>{'Name'}, false) ;
                for(Affiliation_Network__c affiliation : [Select Name from Affiliation_Network__c where Country__c = :countryId order by Name])
                {
                    options.put(affiliation.Id,affiliation.Name);
                }
            return options;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    /**************************************************************
    * Method : Method to fetch Scenario record types for Scenario type drop down.
        Returns map of select options
    ***************************************************************/
    @AuraEnabled
    public static map<String,Scenario_Type__c> getScenarioTypeOptions(){
        map<String,Scenario_Type__c> options = new map<String,Scenario_Type__c>();
        List<Scenario_Type__c> scenarioTypeOptions = Scenario_Type__c.getAll().values();
        for(Scenario_Type__c scn: scenarioTypeOptions){
            options.put(scn.name,scn);
        }
        return options;
    }
 

    /**************************************************************
    * Method : Method to fetch values for Scenario creation type drop down.
        Returns map of select options
    * Param 1 : selected scenario type
    ***************************************************************/
    @AuraEnabled
    public static map<String,String> getCreationTypeOptions(string selectedScenarioName){
        map<String,String> options = new map<String,String>();
        system.debug('#### selectedScenarioName : '+selectedScenarioName);
        Alignment_Global_Settings__c creationTypeSettings = Alignment_Global_Settings__c.getValues(selectedScenarioName);
        if(creationTypeSettings != null && selectedScenarioName != null){
            for(String creationType : creationTypeSettings.Tree_Hierarchy_Sort_Field__c.split(';')){
                options.put(creationType,creationType);
            }
        }

        return options;
    }


    /**************************************************************
    * Method : Fetch all team instance options for team drop down.
        Returns map of team instance id and team instance name
    * Param 1 : selected scenario type
    * Param 2 : selected team sfid, selected scenario type
    ***************************************************************/
    @AuraEnabled
    public static map<String,String> getTeamInstanceOptions(string teamId, String scenarioType){
        try {
            String ns = SalesIQGlobalConstants.NAME_SPACE;
            map<String,String> options = new map<String,String>();
            System.debug('scenarioType -- '+scenarioType);

            SecurityUtil.checkRead(Team_Instance__c.SObjectType, new list<string>{'Name'}, false) ;

            String query = '';
            String liveStage = SalesIQGlobalConstants.LIVE;
            String pastStage = SalesIQGlobalConstants.PAST;
            String activeStatus = SalesIQGlobalConstants.SCENARIO_STATUS_ACTIVE;

            String alignmentTypeScenario = SalesIQGlobalConstants.SCENARIO_TYPE_ALIGNMENT;

            //List<Server_Thresholds__c> copyNonLiveScenarios = [SELECT Load_Count__c FROM Server_Thresholds__c where Name = 'Copy Non Live Scenarios'];

            if(scenarioType!=null){
                if(scenarioType.equalsIgnoreCase(alignmentTypeScenario)){
                    //Copy Non Live Scenarios
                    //SIMPS - 1349

                    query = 'Select id, Name, Scenario__r.Name,Scenario__c,Scenario__r.Scenario_Name__c,Scenario__r.Scenario_Type__c from Team_Instance__c where Team__c =: teamId and ( Scenario__c = null or ( Scenario__r.Scenario_Stage__c=: liveStage and Scenario__r.Scenario_Status__c =: activeStatus )';
                    
                    //if(copyNonLiveScenarios != null && copyNonLiveScenarios.size() > 0)
                    //{
                        query += ' or ( Scenario__r.Scenario_Status__c =: activeStatus)';
                    //}

                    query += ')  order by Name';

                }else if(scenarioType.equalsIgnoreCase(SalesIQGlobalConstants.SCENARIO_TYPE_CALL_PLAN)){

                    query = 'Select id, Name, Scenario__r.Name,Scenario__c,Scenario__r.Scenario_Name__c,Scenario__r.Scenario_Type__c from Team_Instance__c where Team__c =: teamId and (Scenario__c=null or (Scenario__r.Scenario_Stage__c <>: pastStage and Scenario__r.Scenario_Status__c =: activeStatus and Scenario__r.Scenario_Type__c =: alignmentTypeScenario )';

                    //if(copyNonLiveScenarios != null && copyNonLiveScenarios.size() > 0)
                    //{
                        query += ' or ( Scenario__r.Scenario_Status__c =: activeStatus)';
                    //}

                    query += ')  order by Name';
                }   
                for(Team_Instance__c teamIns : Database.query(query))
                {
                    if(teamIns.Scenario__c == null)
                    {
                        options.put(teamIns.Id,teamIns.Name);
                    }
                    else
                    {
                        String teamInsName = teamIns.getSObject(ns+'Scenario__r').get('Name') + ' ' + teamIns.Name;
                        options.put(teamIns.Id,teamInsName);
                    }
                }
            }
            return options;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    /**************************************************************
    * Method : Fetch the sample document template to create
        scenario from file
    ***************************************************************/
    @AuraEnabled
    public static Document getDocumentTemplate(String scenarioType)
    {
        try{
            String DOCUMENT_NAME = '';
            if(scenarioType == SalesIQGlobalConstants.SCENARIO_TYPE_CALL_PLAN){
                DOCUMENT_NAME = 'Call_Plan_Template';
            }else{
                DOCUMENT_NAME = 'Alignment_Template';
            }
            Document template = [SELECT BodyLength,ContentType,LastModifiedDate,Description,Id,Name,Type FROM Document WHERE DeveloperName =: DOCUMENT_NAME Limit 1];
            return template;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    /**************************************************************
    * Method : Method returns Team Instance Object basis its Id 

    ***************************************************************/
    @AuraEnabled
    public static Team_Instance__c getTeamInstanceById(String teamInstanceId){
        try{
            return SalesIQUtility.getTeamInstanceById(teamInstanceId);
        }
        catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }


    @AuraEnabled
    public static Boolean getShared(String teamInstanceId){
        try{
            list<Team_Instance__c> teamInst = [Select Id, EnableAccountSharing__c, Restrict_ZIP_Share__c, Alignment_Type__c From Team_Instance__c where id =: teamInstanceId limit 1];
            system.debug('teamInst'+teamInst);
            Boolean shared =false;
            if(teamInst.size() > 0){
                if(teamInst[0].EnableAccountSharing__c == true && teamInst[0].Alignment_Type__c == SalesIQGlobalConstants.ALIGNMENT_TYPE_ACCOUNT){
                    shared = true;
                }
                else if(teamInst[0].Restrict_ZIP_Share__c == false && teamInst[0].Alignment_Type__c == SalesIQGlobalConstants.ALIGNMENT_TYPE_ZIP){
                    shared = true;
                }
                else if((teamInst[0].EnableAccountSharing__c == true || teamInst[0].Restrict_ZIP_Share__c == false) && teamInst[0].Alignment_Type__c == SalesIQGlobalConstants.ALIGNMENT_TYPE_HYBRID){
                    shared = true;
                }
            }
            return shared;
        }
        catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }
    
    /*
        Method to fetch summary data for selected team instance.
        Returns object of type SummaryWrapper with aggregated data.
    */
    @AuraEnabled
    public Static list<SummaryWrapper> getSummary(string teamInstanceId, String workspaceId){
        try{
            list<SummaryWrapper> listSummaryWrapper = new list<SummaryWrapper>();
            
            map<string,string> hierarchyConfigMap = new map<string,string>();

            SecurityUtil.checkRead(CR_Team_Instance_Config__c.SObjectType, new list<string>{'Configuration_Value__c','Configuration_Name__c','Configuration_Type__c','Team_Instance__c'}, false) ;
            for(CR_Team_Instance_Config__c config : [Select Configuration_Value__c, Configuration_Name__c From CR_Team_Instance_Config__c where Configuration_Type__c = 'Hierarchy Configuration' and Team_Instance__c =: teamInstanceId]){
                hierarchyConfigMap.put(config.Configuration_Name__c,config.Configuration_Value__c);
            }
            
            // query to get workspace start date , all queries changed to get positions end date >= workspace start date
            Workspace__c workspace = [select id, Workspace_Start_Date__c, Workspace_End_Date__c from Workspace__c where id=: workspaceId];
            Date workspaceDate = workspace.Workspace_Start_Date__c;
            
            SecurityUtil.checkRead(Position__c.SObjectType, new list<string>{'Hierarchy_Level__c','Team_Instance__c'}, false) ;
            AggregateResult[] positionSummary = [SELECT count(Id) cnt, Hierarchy_Level__c FROM Position__c where Team_Instance__c =: teamInstanceId AND Effective_End_Date__c >=: workspaceDate AND inactive__c = false group by Hierarchy_Level__c order by Hierarchy_Level__c]; 
            for (AggregateResult ar : positionSummary) {
                    String hierarchy = '';
                    if( ( ar != null ) && ( ar.get( SalesIQGlobalConstants.NAME_SPACE+'Hierarchy_Level__c') != null ) ){
                        String level =  (string)ar.get(SalesIQGlobalConstants.NAME_SPACE+'Hierarchy_Level__c');
                        if( level!= null && hierarchyConfigMap.containsKey(level) ){
                            hierarchy = ( hierarchyConfigMap.get(level)).toLowerCase();
                        }
                        
                    }
                    
                    if(hierarchy.contains(SalesIQGlobalConstants.POSITION_TYPE_NATION.toLowerCase())){
                        hierarchy = System.Label.Nation;
                    }else if(hierarchy.contains(SalesIQGlobalConstants.POSITION_TYPE_TERRITORY.toLowerCase())){
                        hierarchy = System.Label.Territory;
                    }else if(hierarchy.contains(SalesIQGlobalConstants.POSITION_TYPE_DISTRICT.toLowerCase())){
                        hierarchy = System.Label.District;
                    }else if(hierarchy.contains(SalesIQGlobalConstants.POSITION_TYPE_REGION.toLowerCase())){
                        hierarchy = System.Label.Region;
                    }

                    listSummaryWrapper.add(new SummaryWrapper(System.Label.TITLE_NUMBER_OF+' '+hierarchy,(integer)ar.get('cnt')));
            }
            
            SecurityUtil.checkRead(Position_Account__c.SObjectType, new list<string>{'Team_Instance__c','Assignment_Status__c'}, false) ;
            //AggregateResult[] accountSummary = [SELECT count(Id) cnt FROM Position_Account__c where Team_Instance__c =: teamInstanceId and Assignment_Status__c = 'Active' AND Position__r.Effective_End_Date__c >=: workspaceDate group by Team_Instance__c];
            
            list<String> assignmentStatusList = new list<String>();
            assignmentStatusList.add(SalesIQGlobalConstants.POSITION_GEOGRAPHY_ACTIVE);
            assignmentStatusList.add(SalesIQGlobalConstants.POSITION_GEOGRAPHY_FUTURE_ACTIVE);

            AggregateResult[] accountSummary = [SELECT count(Id) cnt FROM Position_Account__c where Team_Instance__c =: teamInstanceId and Assignment_Status__c in: assignmentStatusList AND Position__r.Effective_End_Date__c >=: workspaceDate group by Team_Instance__c];

            if(accountSummary.size() > 0){
                listSummaryWrapper.add(new SummaryWrapper(System.Label.TITLE_NUMBER_OF_ACCOUNTS,(integer)accountSummary[0].get('cnt')));
            }else{
                listSummaryWrapper.add(new SummaryWrapper(System.Label.TITLE_NUMBER_OF_ACCOUNTS,0));
            }
            
            SecurityUtil.checkRead(Position_Employee__c.SObjectType, new list<string>{'Position__c','Assignment_Status__c'}, false) ;
            SecurityUtil.checkRead(Position__c.SObjectType, new list<string>{'Team_Instance__c'}, false) ;
            AggregateResult[] emplpoyeeSummary = [SELECT count(Id) cnt FROM Position_Employee__c where Position__r.Team_Instance__c =: teamInstanceId and Assignment_Status__c = 'Active' AND Position__r.Effective_End_Date__c >=: workspaceDate group by Position__r.Team_Instance__c];
            if(emplpoyeeSummary.size() > 0){
                listSummaryWrapper.add(new SummaryWrapper(System.Label.TITLE_NUMBER_OF_EMP_ASSIGNMENTS,(integer)emplpoyeeSummary[0].get('cnt')));
            }else{
                listSummaryWrapper.add(new SummaryWrapper(System.Label.TITLE_NUMBER_OF_EMP_ASSIGNMENTS,0));
            }
            
            return listSummaryWrapper;
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }
    


    /*
        Method : Method to create scenario from existing LIVE scenario : SIQ 1022
    */
    @AuraEnabled
    public Static map<string,string> createScenario(string workspaceId, string name, string teamId, string teamInstanceId,String description, string scenarioType,string scenarioTypeName, String geoType, String affiliationNetwork, Boolean copyexistingscenarioflag, String dataSourceWrapper, string baseTeamInstance, string convergingLevel, Boolean shared){
        try {
            SecurityUtil.checkRead(Workspace__c.SObjectType, new list<string>{'Workspace_Start_Date__c','Workspace_End_Date__c'}, false) ;
            Workspace__c workspace = [select id, Workspace_Start_Date__c, Workspace_End_Date__c from Workspace__c where id =: workspaceId];
            
            String namespace=SalesIQGlobalConstants.NAME_SPACE;
            String objectAPIName = namespace+'Scenario__c' ;
            Id recordTypeId = Schema.getGlobalDescribe().get(objectAPIName).getDescribe().getRecordTypeInfosByName().get(scenarioTypeName).getRecordTypeId();

            Scenario__c s = new Scenario__c();
           
            s.Workspace__c = workspace.Id;
            s.Scenario_Name__c = name;
            s.Team_Name__c = teamId;
            s.Description__c = description;
            s.Source_Team_Instance__c = teamInstanceId;
            s.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
            s.Effective_End_Date__c = workspace.Workspace_End_Date__c;
            s.Scenario_Stage__c = 'Design';
            s.Request_Process_Stage__c = 'In Queue';
            s.Scenario_Status__c = 'Inactive';
            s.Scenario_Alignment_Level__c = 'National';
            if(scenarioType != '')
                s.RecordTypeId = recordTypeId;
            s.Scenario_Type__c = scenarioTypeName;
            s.CR_Tracking__c = false;
            s.Scenario_Source__c = 'Existing Scenario';
            s.Skip_Data_Validation__c = true;
            /*s.EnableEmployeeAssignment__c = employeeAssignment;*/
            SecurityUtil.checkInsert(Scenario__c.SObjectType, new list<string>{'Scenario_Name__c','Workspace__c','Team_Name__c','Source_Team_Instance__c','Effective_Start_Date__c','Effective_End_Date__c','Scenario_Stage__c','Request_Process_Stage__c','Scenario_Status__c','Scenario_Source__c'}, false) ;
            insert s;
            
            list<string> TEAM_INSTANCE_READ_FIELDS = new list<string>{'Geography_Type_Name__c','isActiveCycle__c','ZIPMovement__c','Team__c','Team_Cycle_Name__c','Scenario__c','Restrict_Update_Position_Attribute__c','Restrict_Hierarchy_Change__c','Rep_End_Date__c','ReadOnlyEditPosition__c','ReadOnlyDeletePosition__c','ReadOnlyCreatePosition__c','POA_EffStartDate__c','POA_EffEndDate__c','Name','IsCascadeDeleteAssignments__c','IsAllowedManageAssignment__c','IC_EffstartDate__c','IC_EffEndDate__c','DM_End_Date__c','Base_Team__c', 'Alignment_Type__c', 'Alignment_Period__c', 'AccountMovement__c','Restrict_ZIP_Share__c'};
            SecurityUtil.checkRead(Team_Instance__c.SObjectType, TEAM_INSTANCE_READ_FIELDS, false) ;
            Team_Instance__c copyTeamInstance = [ Select Id, Scenario__r.Business_Rule_Template__c, Scenario__r.Enable_Affiliation_Based_Alignment__c, Scenario__r.File_Path__c, isActiveCycle__c, ZIPMovement__c, Team__c, Team_Cycle_Name__c, Scenario__c, Restrict_Update_Position_Attribute__c, 
                                                 Restrict_Hierarchy_Change__c, Rep_End_Date__c, ReadOnlyEditPosition__c, ReadOnlyDeletePosition__c, ReadOnlyCreatePosition__c, 
                                                 POA_EffStartDate__c, POA_EffEndDate__c, Name, IsCascadeDeleteAssignments__c, IsAllowedManageAssignment__c, IC_EffstartDate__c, 
                                                 IC_EffEndDate__c, Geography_Type_Name__c,DM_End_Date__c, Base_Team__c, Alignment_Type__c, Alignment_Period__c, AccountMovement__c,
                                                 Restrict_ZIP_Share__c,CIM_Available__c,Shared_Position_Threshold__c, Account_Shared_Position_Threshold__c,EnableAccountSharing__c,
                                                 Allow_Account_Exclusion__c, Affiliation_Network__c,Show_Custom_Metric__c,Restrict_Account_Affiliation__c,Show_Map__c, Scenario__r.Allow_Product_Level_Rules__c  
                                                 From Team_Instance__c where id =: teamInstanceId limit 1 ];
            
            
            Team_Instance__c scenarioTeamInstance = copyTeamInstance.clone(false, true, false, false);
            scenarioTeamInstance.Name = s.Scenario_Name__c;
            scenarioTeamInstance.Scenario__c = s.Id;
            scenarioTeamInstance.AccountMovement__c = false;
            scenarioTeamInstance.ReadOnlyCreatePosition__c = false;
            scenarioTeamInstance.ReadOnlyDeletePosition__c = false;
            scenarioTeamInstance.ReadOnlyEditPosition__c = false;
            scenarioTeamInstance.Restrict_Hierarchy_Change__c = false;
            scenarioTeamInstance.IsAllowedManageAssignment__c = false;
            scenarioTeamInstance.Restrict_Update_Position_Attribute__c = false;
            scenarioTeamInstance.ZIPMovement__c = false;
            if(shared==true){
                scenarioTeamInstance.Restrict_ZIP_Share__c = false;
                scenarioTeamInstance.EnableAccountSharing__c = true;
            }
            else if(shared ==false){
                scenarioTeamInstance.Restrict_ZIP_Share__c = true;
                scenarioTeamInstance.EnableAccountSharing__c = false;
            }
            if(workspace.Workspace_Start_Date__c > system.today()){
                scenarioTeamInstance.Alignment_Period__c = SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE;
                scenarioTeamInstance.Team_Cycle_Name__c = SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE;
            }else{
                scenarioTeamInstance.Alignment_Period__c = SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE;
                scenarioTeamInstance.Team_Cycle_Name__c = SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE;
            }

            scenarioTeamInstance.IC_EffstartDate__c = workspace.Workspace_Start_Date__c;
            scenarioTeamInstance.IC_EffEndDate__c = workspace.Workspace_End_Date__c;
            //scenarioTeamInstance.Geography_Type_Name__c = geoType;
            if(! string.isBlank(convergingLevel)){
                scenarioTeamInstance.Converging_Level__c = integer.valueOf(convergingLevel) ;
            }
            if(!string.isBlank(baseTeamInstance)){
                scenarioTeamInstance.Base_team_Instance__c = baseTeamInstance;
            }
            
            
            
            system.debug('### scenarioTeamInstance ###'+scenarioTeamInstance);
            
            SecurityUtil.checkInsert(Team_Instance__c.SObjectType, new list<string>{'Geography_Type_Name__c','Name','Scenario__c','Alignment_Period__c','Team_Cycle_Name__c','IC_EffstartDate__c','IC_EffEndDate__c'}, false) ;
            insert scenarioTeamInstance;


            //GET EXISTING SCENARIO ATTRIBUTES SIQ 1022
            Team_Instance__c existingScenario = [SELECT Id,Scenario__c, Scenario__r.Business_Rule_Template__c, Scenario__r.Enable_Affiliation_Based_Alignment__c, Scenario__r.File_Path__c FROM Team_Instance__c WHERE Id =: teamInstanceId limit 1 ];

            s.File_Path__c = copyTeamInstance.Scenario__r.File_Path__c;
            s.Business_Rule_Template__c = copyTeamInstance.Scenario__r.Business_Rule_Template__c;
            s.Team_Instance__c = scenarioTeamInstance.Id;
            s.Enable_Affiliation_Based_Alignment__c = copyTeamInstance.Scenario__r.Enable_Affiliation_Based_Alignment__c;
            s.Allow_Product_Level_Rules__c = copyTeamInstance.Scenario__r.Allow_Product_Level_Rules__c;


            SecurityUtil.checkUpdate(Scenario__c.SObjectType, new list<string>{'Team_Instance__c'}, false) ;
            update s;
            
            list<User_Access_Permission__c> userAccessToInsert = new list<User_Access_Permission__c>();
            set<string> userIds = ScenarioUtility.getUsersOfHOLevelProfile();
            for(string userId : userIds){
                User_Access_Permission__c userAccess = new User_Access_Permission__c();
                userAccess.Name = s.Scenario_Name__c;
                userAccess.Team_Instance__c = scenarioTeamInstance.Id;
                userAccess.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
                userAccess.Effective_End_Date__c = workspace.Workspace_End_Date__c;
                userAccess.Is_Active__c = false;
                userAccess.User__c = userId;
                userAccessToInsert.add(userAccess);
            }
            if(!userIds.contains(UserInfo.getUserId())){
                User_Access_Permission__c userAccess = new User_Access_Permission__c();
                userAccess.Name = s.Scenario_Name__c;
                userAccess.Team_Instance__c = scenarioTeamInstance.Id;
                userAccess.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
                userAccess.Effective_End_Date__c = workspace.Workspace_End_Date__c;
                userAccess.Is_Active__c = false;
                userAccess.User__c = UserInfo.getUserId();
                userAccessToInsert.add(userAccess);
            }
            
            if(userAccessToInsert.size() > 0){
                SecurityUtil.checkInsert(User_Access_Permission__c.SObjectType, new list<string>{'Name','Team_Instance__c','Effective_Start_Date__c','Effective_End_Date__c','Is_Active__c','User__c'}, false) ;
                insert userAccessToInsert;
            }
            
            SecurityUtil.checkRead(Scenario__c.SObjectType, new list<string>{'Name','Scenario_Name__c'}, false) ;
            Scenario__c newScenario = [select Name, Scenario_Name__c from Scenario__c where id =: s.Id];
            String newscenarioid = newScenario.Id;
            String selectedscenarioid = copyTeamInstance.Scenario__c;
            Id templateid = copyTeamInstance.Scenario__r.Business_Rule_Template__c;


            List<DataSourceWrapper> existingDataSourceWrapper = new List<DataSourceWrapper>();
            List<DataSourceWrapper> newScenarioDataSourceWrapper = new List<DataSourceWrapper>(); 
            Map<String,String> externalDataSourceNameToFileName = new Map<String,String>();

            // GET EXTERNAL DATA OBJECT SOURCES FROM NEW SCENARIO
            newScenarioDataSourceWrapper = getExternalDataSourceFromScenario(selectedscenarioid);

            // GET EXTERNAL DATA OBJECT SOURCES FROM EXISTING SCENARIO
            if(dataSourceWrapper != null &&  dataSourceWrapper.length() > 0){
                existingDataSourceWrapper = (list<DataSourceWrapper>)JSON.deserialize(dataSourceWrapper,list<DataSourceWrapper>.class);
            }

            // GET FILE NAME IF ANY FROM USER INPUT FOR EXTERNAL DATA OBJECT SOURCES FROM EXISTING SCENARIO ON COPY SCENARIO
            for(DataSourceWrapper obj :existingDataSourceWrapper){
                if(obj.filePath != null && obj.filePath != '' && obj.filePath.length() > 0){
                    externalDataSourceNameToFileName.put(obj.dataSetName, obj.filePath);
                }    
            }

            // ADD FILE NAME TO NEW SCENARIO DATA SOURCES SUPPLIED
            for(DataSourceWrapper obj :newScenarioDataSourceWrapper){
                if(externalDataSourceNameToFileName.containsKey(obj.dataSetName)){
                    obj.filepath = externalDataSourceNameToFileName.get(obj.dataSetName);
                }
            }
            copyExistingScenario(newscenarioid,copyexistingscenarioflag,selectedscenarioid);
            saveOnDataObjectAndScenarioDataObjectMap( JSON.serialize(newScenarioDataSourceWrapper), newscenarioid, templateid, true);
            updateScenarioDataObjectMap(newscenarioid);
           
            return new map<string,string>{newScenario.Id => newScenario.Scenario_Name__c};
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    /*
        Method Bound with save on CreateScenarioFromFile component.
        Create a new scenario record and team instance.
        Returns Id of newly created scenario record.
    */
    @AuraEnabled
    public Static map<string,string> createScenarioFromFile(string workspaceId, string name, string teamId, string filePath,String description,string scenarioType,string scenarioTypeName,string teamInstanceId, String geoType, String affiliationNetwork,String templateid,String dataSourceWrapper,Boolean affilationChecked, Boolean skipValidation, Boolean employeeAssignment, Boolean shared, string baseTeamInstance, string convergingLevel){
        
        try {
            SecurityUtil.checkRead(Workspace__c.SObjectType, new list<string>{'Workspace_Start_Date__c','Workspace_End_Date__c'}, false) ;
            Workspace__c workspace = [select id, Workspace_Start_Date__c, Workspace_End_Date__c from Workspace__c where id =: workspaceId];

           
            String namespace=SalesIQGlobalConstants.NAME_SPACE;
            String objectAPIName = namespace+'Scenario__c' ; //any object api
            Id recordTypeId = Schema.getGlobalDescribe().get(objectAPIName).getDescribe().getRecordTypeInfosByName().get(scenarioTypeName).getRecordTypeId();

            Scenario__c s = new Scenario__c();
            s.Scenario_Name__c = name;
            s.Workspace__c = workspace.Id;
            s.Team_Name__c = teamId;
            s.Description__c = description;
            s.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
            s.Effective_End_Date__c = workspace.Workspace_End_Date__c;
            if(scenarioTypeName =='Alignment Scenario')
                s.Scenario_Stage__c = 'Design';
            else
                s.Scenario_Stage__c ='Collaboration';
            s.Request_Process_Stage__c = 'In Queue';
            s.Scenario_Status__c = 'Inactive';
            s.Scenario_Alignment_Level__c = 'National';
            if( templateid!=null && templateid!='' && templateid != 'None')
                s.Business_Rule_Template__c = templateid;
            if(scenarioType != '')
                s.RecordTypeId = recordTypeId;
            s.Scenario_Type__c = scenarioTypeName;
            s.CR_Tracking__c = false;
            s.File_Path__c = filePath;
            s.Scenario_Source__c = 'File';
            s.Enable_Affiliation_Based_Alignment__c = affilationChecked;
            s.Skip_Data_Validation__c = true;
            s.EnableEmployeeAssignment__c = employeeAssignment;
            SecurityUtil.checkInsert(Scenario__c.SObjectType, new list<string>{'Scenario_Name__c','Workspace__c','Team_Name__c','Source_Team_Instance__c','Effective_Start_Date__c','Effective_End_Date__c','Scenario_Stage__c','Request_Process_Stage__c','Scenario_Status__c','File_Path__c','Scenario_Source__c'}, false) ;
            insert s;
            
            list<string> TEAM_READ_FIELDS = new list<string>{'Alignment_Type__c'};
            SecurityUtil.checkRead(Team__c.SObjectType, TEAM_READ_FIELDS, false) ;
            Team__c team = [Select Id, Alignment_Type__c from Team__c where Id =: teamId];

            list<string> TEAM_INSTANCE_READ_FIELDS = new list<string>{'Geography_Type_Name__c','isActiveCycle__c','Team_Cycle_Name__c','Scenario__c','Name','IC_EffstartDate__c','IC_EffEndDate__c','Alignment_Type__c', 'Alignment_Period__c'};
            SecurityUtil.checkRead(Team_Instance__c.SObjectType, TEAM_INSTANCE_READ_FIELDS, false) ;
            Team_Instance__c scenarioTeamInstance = new Team_Instance__c();
            if(scenarioTypeName =='Alignment Scenario')
            {
                
                scenarioTeamInstance.Name = s.Scenario_Name__c;
                scenarioTeamInstance.Scenario__c = s.Id;
                if(workspace.Workspace_Start_Date__c > system.today()){
                    scenarioTeamInstance.Alignment_Period__c = SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE;
                    scenarioTeamInstance.Team_Cycle_Name__c = SalesIQGlobalConstants.FUTURE_TEAM_CYCLE_TYPE;
                }else{
                    scenarioTeamInstance.Alignment_Period__c = SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE;
                    scenarioTeamInstance.Team_Cycle_Name__c = SalesIQGlobalConstants.CURRENT_TEAM_CYCLE_TYPE;
                }
                scenarioTeamInstance.IC_EffstartDate__c = workspace.Workspace_Start_Date__c;
                scenarioTeamInstance.IC_EffEndDate__c = workspace.Workspace_End_Date__c;
                scenarioTeamInstance.Team__c = teamId;
                scenarioTeamInstance.Restrict_ZIP_Share__c = true;
                scenarioTeamInstance.Alignment_Type__c = team.Alignment_Type__c;
                scenarioTeamInstance.Geography_Type_Name__c = geoType;
                

                //MAKE CIM FALSE WHEN NO EXTERAL DATASOURCE FILE IS SUPPLIED
                list<DataSourceWrapper> lstDataSrcWrapper = (list<DataSourceWrapper>)JSON.deserialize(DataSourceWrapper,list<DataSourceWrapper>.class);
                Set<String> inputCIMFileNames = new Set<String>();
                for(DataSourceWrapper ds :lstDataSrcWrapper){
                    if(ds.filepath !=  null && ds.filepath != ''){
                        inputCIMFileNames.add(ds.filepath);
                    }
                }
                if( inputCIMFileNames.size() > 0 ){
                    scenarioTeamInstance.CIM_Available__c = true;
                }else{
                    scenarioTeamInstance.CIM_Available__c = false;
                }
                
                scenarioTeamInstance.Shared_Position_Threshold__c = 3;
                scenarioTeamInstance.Account_Shared_Position_Threshold__c = 50;
                scenarioTeamInstance.show_Map__c = true;
                
                // Enable Account Sharing always if it is Alignment Sceanrio and Template is selected
                if(s.Business_Rule_Template__c != null) {
                    scenarioTeamInstance.EnableAccountSharing__c = true;
                    //SIMPS-405, Not required
                    //scenarioTeamInstance.Account_Shared_Position_Threshold__c = 100;
                }

                if(affiliationNetwork != '' && affiliationNetwork != null && affiliationNetwork != 'None'){
                    scenarioTeamInstance.Affiliation_Network__c = affiliationNetwork;
                    scenarioTeamInstance.Restrict_Account_Affiliation__c = false;
                }
                else
                    scenarioTeamInstance.Restrict_Account_Affiliation__c = true;

                if(shared==true){
                    scenarioTeamInstance.Restrict_ZIP_Share__c = false;
                    scenarioTeamInstance.EnableAccountSharing__c = true;
                }
                else if(shared ==false){
                    scenarioTeamInstance.Restrict_ZIP_Share__c = true;
                    scenarioTeamInstance.EnableAccountSharing__c = false;
                }
                if(! string.isBlank(convergingLevel)){
                    scenarioTeamInstance.Converging_Level__c = integer.valueOf(convergingLevel) ;
                }
                if(!string.isBlank(baseTeamInstance)){
                    scenarioTeamInstance.Base_team_Instance__c = baseTeamInstance;
                }
                

                SecurityUtil.checkInsert(Team_Instance__c.SObjectType, new list<string>{'Geography_Type_Name__c','Name','Scenario__c','Alignment_Period__c','Team_Cycle_Name__c','IC_EffstartDate__c','IC_EffEndDate__c','Base_team_Instance__c','Converging_Level__c'}, false) ;
                insert scenarioTeamInstance;

                s.Team_Instance__c = scenarioTeamInstance.Id;
            }
            else
            {
               s.Team_Instance__c= teamInstanceId;
            }
            SecurityUtil.checkUpdate(Scenario__c.SObjectType, new list<string>{'Team_Instance__c'}, false) ;
            update s;
            
            list<User_Access_Permission__c> userAccessToInsert = new list<User_Access_Permission__c>();
            if(scenarioTypeName == 'Alignment Scenario'){
                set<string> userIds = ScenarioUtility.getUsersOfHOLevelProfile();
                for(string userId : userIds){
                    User_Access_Permission__c userAccess = new User_Access_Permission__c();
                    userAccess.Name = s.Scenario_Name__c;
                    userAccess.Team_Instance__c = scenarioTeamInstance.Id;
                    userAccess.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
                    userAccess.Effective_End_Date__c = workspace.Workspace_End_Date__c;
                    userAccess.Is_Active__c = false;
                    userAccess.User__c = userId;
                    userAccessToInsert.add(userAccess);
                }
                if(!userIds.contains(UserInfo.getUserId())){
                    User_Access_Permission__c userAccess = new User_Access_Permission__c();
                    userAccess.Name = s.Scenario_Name__c;
                    userAccess.Team_Instance__c = scenarioTeamInstance.Id;
                    userAccess.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
                    userAccess.Effective_End_Date__c = workspace.Workspace_End_Date__c;
                    userAccess.Is_Active__c = false;
                    userAccess.User__c = UserInfo.getUserId();
                    userAccessToInsert.add(userAccess);
                }
            }
            
            if(userAccessToInsert.size() > 0){
                SecurityUtil.checkInsert(User_Access_Permission__c.SObjectType, new list<string>{'Name','Team_Instance__c','Effective_Start_Date__c','Effective_End_Date__c','Is_Active__c','User__c'}, false) ;
                insert userAccessToInsert;
            }
            
            SecurityUtil.checkRead(Scenario__c.SObjectType, new list<string>{'Name','Scenario_Name__c'}, false) ;
            Scenario__c newScenario = [select Name, Scenario_Name__c from Scenario__c where id =: s.Id];
            if(templateid != null){
                saveOnCanvas(templateid,newScenario.Id);
                saveOnDataObjectAndScenarioDataObjectMap(dataSourceWrapper,newScenario.Id,templateid,false);
                updateScenarioDataObjectMap(newScenario.Id);
                removeAffiliationComponents( scenarioTeamInstance.Restrict_Account_Affiliation__c,newScenario.Id);
            }
            
            return new map<string,string>{newScenario.Id => newScenario.Scenario_Name__c};
        } catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static void removeAffiliationComponents(Boolean ifAffliation,String scenarioId ){
        List<Scenario_Rule_Instance_Details__c> affiliationList = new List<Scenario_Rule_Instance_Details__c>();
        if(ifAffliation){
            
            List<Scenario_Rule_Instance_Details__c> scenarioDetailsObj = [SELECT Id, Name, ComponentTypeLabel__c, Parent_Display_Order_Summarize__c, Parent_Display_Order__c, Component_Display_Order__c, Component_Display_Order_Summarize__c, Is_Editable__c, Is_Visible__c, Scenario_Id__c FROM Scenario_Rule_Instance_Details__c where Scenario_Id__c= :scenarioId and Component_Type_Master__r.Name = 'Affiliation'];

            if(!scenarioDetailsObj.isEmpty()) {
                List<Data_Set_Rule_Map__c> dsrmListAffiliation = [SELECT Id, Business_Rule_Template_Details__c, DS_Rule_Map_Id__c, dataset_id__c,File_Type__c, Name, Table_Display_Name__c, scenario_rule_instance_id__c FROM Data_Set_Rule_Map__c where scenario_rule_instance_id__c = :scenarioDetailsObj[0].Id and ((ds_type__c = 'I' and File_Type__c='Affiliation') or (ds_type__c ='O'))];
                system.debug('####DSRMListaffiliation'+dsrmListAffiliation);

                Set<Id> datasSetIds = new Set<Id>(); 
                for(Data_Set_Rule_Map__c dsrm : dsrmListAffiliation){
                    datasSetIds.add(dsrm.dataset_id__c);
                }

                List<Data_Set_Rule_Map__c> finalDSRM =  [SELECT Id, Business_Rule_Template_Details__c, DS_Rule_Map_Id__c, dataset_id__c, dataset_id__r.Is_Upstream__c,File_Type__c, Name, Table_Display_Name__c, scenario_rule_instance_id__c, scenario_rule_instance_id__r.Component_Display_Order__c, scenario_rule_instance_id__r.Component_Display_Order_Summarize__c, scenario_rule_instance_id__r.Parent_Display_Order__c, scenario_rule_instance_id__r.Parent_Display_Order_Summarize__c FROM Data_Set_Rule_Map__c where dataset_id__c in :datasSetIds and ds_type__c='O' and scenario_rule_instance_id__c != :scenarioDetailsObj[0].Id ];
                
                system.debug('####finalDSRM'+finalDSRM);
                scenarioDetailsObj[0].Is_Visible__c = false;
                scenarioDetailsObj[0].Is_Visible_Summarize__c = false;
                affiliationList.addall(scenarioDetailsObj);


                for(Data_Set_Rule_Map__c dateSetRuleMap : finalDSRM){
                    Scenario_Rule_Instance_Details__c srid = new Scenario_Rule_Instance_Details__c(Id = dateSetRuleMap.scenario_rule_instance_id__c);

                    if(dateSetRuleMap.dataset_id__r.Is_Upstream__c == true)
                    {
                        srid.Component_Display_Order__c = dateSetRuleMap.scenario_rule_instance_id__r.Component_Display_Order__c - 1;
                        srid.Component_Display_Order_Summarize__c = dateSetRuleMap.scenario_rule_instance_id__r.Component_Display_Order_Summarize__c - 1;
                        srid.Parent_Display_Order__c = String.valueOf(Integer.valueof(dateSetRuleMap.scenario_rule_instance_id__r.Parent_Display_Order__c) -1);
                        srid.Parent_Display_Order_Summarize__c = String.valueOf(Integer.valueof(dateSetRuleMap.scenario_rule_instance_id__r.Parent_Display_Order_Summarize__c) -1);
                    }
                    else
                    {
                        srid.Is_Visible__c = false;
                        srid.Is_Visible_Summarize__c = false;
                    }
                    
                    affiliationList.add(srid); 
                } 


                system.debug('#####affiliationList'+affiliationList);
                update affiliationList;

            }
        }
    }

    /*
        Method Bound with save on CreateScenario component.
        Create a new scenario record and team instance.
        Returns Id of newly created scenario record.
    */
    @AuraEnabled
    public Static map<string,string> createScenarioFromRule(string workspaceId, string name,string description, string teamId, string teamInstanceId, string fileMetaDataId ,string scenarioType,string scenarioTypeName,string creationType,string businessRuleTemplate){

        
        try{
            SecurityUtil.checkRead(Workspace__c.SObjectType, new list<string>{'Workspace_Start_Date__c','Workspace_End_Date__c'}, false) ;
            Workspace__c workspace = [select id, Workspace_Start_Date__c, Workspace_End_Date__c from Workspace__c where id =: workspaceId];
            Business_Rule_Template__c brtScenarioTemplateId = [Select Id from Business_Rule_Template__c where Id = :businessRuleTemplate];
            Data_Object__c dataSetObj = [SELECT dataset_id__c,data_name__c,Data_Object_Ext_Id__c,Data_Object_Id__c FROM Data_Object__c where Id=:fileMetaDataId];

            String namespace=SalesIQGlobalConstants.NAME_SPACE;
            String objectAPIName = namespace+'Scenario__c' ; //any object api
            Id recordTypeId = Schema.getGlobalDescribe().get(objectAPIName).getDescribe().getRecordTypeInfosByName().get(scenarioTypeName).getRecordTypeId();
            
            
            Scenario__c s = new Scenario__c();
            s.Scenario_Name__c = name;
            s.Description__c = description;
            s.Workspace__c = workspace.Id;
            s.Team_Name__c = teamId;
            s.Team_Instance__c = teamInstanceId;
            s.Effective_Start_Date__c = workspace.Workspace_Start_Date__c;
            s.Effective_End_Date__c = workspace.Workspace_End_Date__c;
            s.Scenario_Stage__c = 'Design';
            s.Request_Process_Stage__c = 'In Queue';
            s.Scenario_Status__c = 'Inactive';
            s.Scenario_Alignment_Level__c = 'National';
            if(brtScenarioTemplateId != null)
                s.Business_Rule_Template__c = brtScenarioTemplateId.Id;
            if(scenarioType != '')
                s.RecordTypeId = recordTypeId;
            s.Scenario_Type__c = scenarioTypeName;
            
            if(creationType == 'Copy scenario from existing'){
                s.Scenario_Source__c = 'Existing Scenario';
            }else if(creationType == 'Upload scenario from file'){
                s.Scenario_Source__c = 'File';
            }else{
                s.Scenario_Source__c = 'Business Rule';
            }
            s.Skip_Data_Validation__c = true;
            s.CR_Tracking__c = false;
            s.Data_Object__c = fileMetaDataId;
            if(scenarioType != '')
                s.RecordTypeId = recordTypeId;

            database.insert(s,true);

            list<string> TEAM_INSTANCE_READ_FIELDS = new list<string>{'isActiveCycle__c','ZIPMovement__c','Team__c','Team_Cycle_Name__c','Scenario__c','Restrict_Update_Position_Attribute__c','Restrict_Hierarchy_Change__c','Rep_End_Date__c','ReadOnlyEditPosition__c','ReadOnlyDeletePosition__c','ReadOnlyCreatePosition__c','POA_EffStartDate__c','POA_EffEndDate__c','Name','IsCascadeDeleteAssignments__c','IsAllowedManageAssignment__c','IC_EffstartDate__c','IC_EffEndDate__c','DM_End_Date__c','Base_Team__c', 'Alignment_Type__c', 'Alignment_Period__c', 'AccountMovement__c'};
            SecurityUtil.checkRead(Team_Instance__c.SObjectType, TEAM_INSTANCE_READ_FIELDS, false) ;
            Team_Instance__c copyTeamInstance = [Select isActiveCycle__c, ZIPMovement__c, Team__c, Team_Cycle_Name__c, Scenario__c, Restrict_Update_Position_Attribute__c, 
                                                 Restrict_Hierarchy_Change__c, Rep_End_Date__c, ReadOnlyEditPosition__c, ReadOnlyDeletePosition__c, ReadOnlyCreatePosition__c, 
                                                 POA_EffStartDate__c, POA_EffEndDate__c, Name, IsCascadeDeleteAssignments__c, IsAllowedManageAssignment__c, IC_EffstartDate__c, 
                                                 IC_EffEndDate__c, DM_End_Date__c, Base_Team__c, Alignment_Type__c, Alignment_Period__c, AccountMovement__c 
                                                 From Team_Instance__c where id =: teamInstanceId];
            
            
            //Insert Scenario Data Map Object
            Scenario_Data_Object_Map__c scenarioDataObjectInstance = new Scenario_Data_Object_Map__c();
            scenarioDataObjectInstance.Data_Object__c = fileMetaDataId;
            scenarioDataObjectInstance.Scenario__c = s.Id;
            scenarioDataObjectInstance.Data_Set__c = dataSetObj.dataset_id__c;
            system.debug('Data_Set__c-->'+dataSetObj.dataset_id__c);
            insert scenarioDataObjectInstance;
            system.debug('scenarioDataObjectInstance-->'+scenarioDataObjectInstance);
            
            
            SecurityUtil.checkRead(Scenario__c.SObjectType, new list<string>{'Name','Scenario_Name__c'}, false) ;
            Scenario__c newScenario = [select Name, Scenario_Name__c,Business_Rule_Template__c from Scenario__c where id =: s.Id];
            system.debug('newScenario:::'+newScenario);
            return new map<string,string>{'0' => newScenario.Id, '1'=> newScenario.Scenario_Name__c, '2' => newScenario.Business_Rule_Template__c};
        }catch(exception e){
            system.debug('#### Error : '+e.getMessage() + 'line :'+e.getLineNumber());
            throw new AuraHandledException(e.getMessage());
        }
    }

    /*
    * Method : Get Active Business Rule templates
    */
    @AuraEnabled
    public static map<String,String> getBusinessRuleTemplateOptions(){
        List<Business_Rule_Template__c> businessRuleTemplateList = new List<Business_Rule_Template__c>();
        map<String,String> options = new map<String,String>();
        businessRuleTemplateList = [Select Id,Name from Business_Rule_Template__c where isActive__c = true and isUniversal__c = false ];
        for(Business_Rule_Template__c obj:businessRuleTemplateList){
            options.put(obj.Id,obj.Name);
        }
        return options;   
    }

    //GET EXTERNAL DATA SOURCES OPTIONS FROM SELECTED RULE TEMPLATE
    @AuraEnabled
    public static map<String,String> getFileMetaDataOptions(String selectedBuisnessRuleTemplateId){
            List<Data_Set_Rule_Map__c> lstDataSetRuleMap = [SELECT Id,Business_Rule_Template_Details__c,dataset_id__c, dataset_id__r.Name FROM Data_Set_Rule_Map__c WHERE Business_Rule_Template_Details__r.Business_Rule_Template_Id__c =: selectedBuisnessRuleTemplateId AND ds_type__c='I' AND dataset_id__r.is_internal__c = false ];

            Set<Id> dataSetIds = new Set<Id>();
            for(Data_Set_Rule_Map__c obj : lstDataSetRuleMap){
                dataSetIds.add(obj.dataset_id__c);
            }
            map<String,String> options = new map<String,String>();
            
            
            for(Data_Object__c file : [Select id,Name from Data_Object__c where status__c = 'Success' AND dataset_id__c in:dataSetIds order by Name]){
                options.put(file.Id,file.Name);
            }
            
            return options;
    }

    /* GET ALIGNMENT TYPE OPTIONS */
    @AuraEnabled
    public static Map<String,String> getAlignmentType(String teamId){
        Map<String,String> options = new Map<String,String>();
        Map<String,String> mapLabelValues = new Map<String,String>();
        
        mapLabelValues.put('account',System.Label.PICKLIST_ACCOUNT_ALIGNMENT_TYPE);
        mapLabelValues.put('zip',System.Label.PICKLIST_ZIP_ALIGNMENT_TYPE);
        mapLabelValues.put('hybrid',System.Label.PICKLIST_HYBRID_ALIGNMENT_TYPE);

        List<Team__c> listTeamOptions = [SELECT Alignment_Type__c from Team__c where id = :teamId ];
        if( listTeamOptions!= null && listTeamOptions.size() > 0 ){
            string alignmentType = listTeamOptions[0].Alignment_Type__c;
            if ( alignmentType != null && ( alignmentType.length() > 0 ) ) {
                options.put( mapLabelValues.get(alignmentType.toLowerCase()), alignmentType );
            }
            
        }      
        return options;
    }

    /* GET ALIGNMENT TYPE OPTIONS */
    @AuraEnabled
    public static Team__c getTeamDetails(String teamId){   
        system.debug('teamId '+teamId);
        Team__c objTeam = new Team__c();     

        List<Team__c> listTeamOptions = [SELECT Alignment_Type__c,type__c from Team__c where id = :teamId limit 1 ];
        if( listTeamOptions!= null && listTeamOptions.size() > 0 ){
            objTeam = listTeamOptions[0];
        }      
        return objTeam;
    }




    //GET BUSINESS RULE TEMPLATE OPTIONS OF EXISTING SCENARIO SIQ 1022
    @AuraEnabled
    public static Business_Rule_Template__c getBusinessRuleTemplateOptionsFromTeamInstance(String teamInstanceId){
        Team_Instance__c existingScenario = [SELECT Scenario__r.Business_Rule_Template__c FROM Team_Instance__c WHERE Id =: teamInstanceId limit 1];
        string templateid = existingScenario.Scenario__r.Business_Rule_Template__c;
        Business_Rule_Template__c businessRuleTemplate = new Business_Rule_Template__c();

        if(templateid != null){
            businessRuleTemplate = [Select Id,Name from Business_Rule_Template__c where id =:templateid LIMIT 1];
            return businessRuleTemplate;
        }else
            return businessRuleTemplate;
    }


    // GET EXTERNAL DATA SOURCES FOR NEW SCEANRIO FROM BUSINESS RULE TEMPLATE
    @AuraEnabled
    public static List<DataSourceWrapper> getCustomerMetricsOptions(String selectedBuisnessRuleTemplateId){
            List<DataSourceWrapper> lstOfDataSources = new List<DataSourceWrapper>();
            List<Data_Set_Rule_Map__c> lstDataSetRuleMap = [SELECT Id,Business_Rule_Template_Details__c,dataset_id__c, dataset_id__r.Name, Table_Display_Name__c FROM Data_Set_Rule_Map__c WHERE Business_Rule_Template_Details__r.Business_Rule_Template_Id__c =: selectedBuisnessRuleTemplateId AND ds_type__c='I' AND dataset_id__r.is_internal__c = false AND dataset_id__r.SalesIQ_Internal__c = false];

            // adding a new set in order to remove duplicate data set inputs
            Set<Id> dataSetIds = new Set<Id>();
            for(Data_Set_Rule_Map__c ruleMap : lstDataSetRuleMap){
                if(!dataSetIds.contains(ruleMap.dataset_id__c)) {
                    lstOfDataSources.add(new DataSourceWrapper(ruleMap.dataset_id__r.Name,ruleMap.dataset_id__c,'', ruleMap.Table_Display_Name__c));
                    dataSetIds.add(ruleMap.dataset_id__c);
                }
            }
            return lstOfDataSources;
    }


    // GET EXTERNAL DATASOURCE FROM EXISTING SCENARIO SIQ 1022
    @AuraEnabled
    public static List<DataSourceWrapper> getExternalDataSourceFromScenario(String selectedscenarioid){
            List<DataSourceWrapper> lstOfDataSources = new List<DataSourceWrapper>();
            List<Data_Set_Rule_Map__c> lstDataSetRuleMap = [SELECT Id,Business_Rule_Template_Details__c,dataset_id__c, dataset_id__r.Name,Table_Display_Name__c, table_name__c , dataset_id__r.Base_Data_Set__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__r.Scenario_Id__c =: selectedscenarioid AND ds_type__c='I' AND dataset_id__r.is_internal__c = false AND dataset_id__r.SalesIQ_Internal__c = false];

            // adding a new set in order to remove duplicate data set inputs
            Set<Id> dataSetIds = new Set<Id>();
            for(Data_Set_Rule_Map__c ruleMap : lstDataSetRuleMap){
                if(!dataSetIds.contains(ruleMap.dataset_id__c)) {
                    lstOfDataSources.add(new DataSourceWrapper(ruleMap.dataset_id__r.Name,ruleMap.dataset_id__c,'', ruleMap.table_name__c));
                    dataSetIds.add(ruleMap.dataset_id__c);
                }
            }
            return lstOfDataSources;
    }
    /*
        Method to check duplicate scenario validations.
        1. If Scenario already exist in pending stage
        2. If scenario already exists with employee assignment enabled for same source team instance.
        3. If scenario already exist with same name.
        Returns validation error in form of string.
    */
    @AuraEnabled
    public static string duplicateScenarioValidation(String TeamInstanceId, string sName, String scenarioType, String createType, string countryId, Boolean employeeAssignment, string teamName, string workspaceId)
    {
        system.debug('#### duplicateScenarioValidation called : '+sName);
        string validationFailedReason = '0';
        try {
            list<string> SCENARIO_READ_FIELD = new list<string>{'Scenario_Name__c','Source_Team_Instance__c','Scenario_Stage__c','Request_Process_Stage__c','Employee_Assignment__c'};
            if (SecurityUtil.checkRead(Scenario__c.SObjectType, SCENARIO_READ_FIELD, false)){
               
                System.debug('sname --- '+sName);
                list<Scenario__c> lstScenarioDuplicateName = [select id, Scenario_Name__c,Scenario_Type__c , Scenario_Stage__c, Request_Process_Stage__c, Employee_Assignment__c, Source_Team_Instance__c from Scenario__c where Scenario_Name__c =: sName and Workspace__r.Country__c =: countryId ];

                if(lstScenarioDuplicateName != null && lstScenarioDuplicateName.size() > 0){

                    System.debug('lstScenarioDuplicateName :'+lstScenarioDuplicateName);
                    validationFailedReason = String.format(System.Label.Scenario_Validation_Duplicate_Name, new List<String>{sName});
                    return validationFailedReason;

                }else{

                    if(scenarioType != null && scenarioType.equalsIgnoreCase(SalesIQGlobalConstants.SCENARIO_TYPE_CALL_PLAN)){

                        if(createType != null && createType.equalsIgnoreCase(System.label.Create_Scenario_From_File)){
                            
                            list<Scenario__c> lstScenarioCPG = [select id, Scenario_Name__c,Scenario_Type__c , Scenario_Stage__c, Request_Process_Stage__c, Employee_Assignment__c, Source_Team_Instance__c from Scenario__c where Team_Instance__c =: TeamInstanceId and Scenario_Type__c =: scenarioType and Request_Process_Stage__c != 'Error Occured'];
                            if(lstScenarioCPG != null && lstScenarioCPG.size() > 0){
                                    validationFailedReason = System.label.CPG_Duplicate_Scenario_Validation;
                            }
                        }
                    }else{  
                        if(TeamInstanceId != null && TeamInstanceId != 'None' && TeamInstanceId != '--None--' && TeamInstanceId != ''){
                            list<Scenario__c> lstScenario = [select id, Scenario_Name__c,Scenario_Type__c , Scenario_Stage__c, Request_Process_Stage__c, Employee_Assignment__c, Source_Team_Instance__c from Scenario__c where Source_Team_Instance__c =: TeamInstanceId];
                            if(lstScenario.size() > 0){
                                for(Scenario__c s : lstScenario){
                                    if(TeamInstanceId != null && s.Request_Process_Stage__c != SalesIQGlobalConstants.READY){
                                        string scenario_name =  s.Scenario_Name__c;
                                        validationFailedReason = string.format(system.label.Scenario_Validation_In_Progress, new list<string>{(scenario_name)});
                                        break;
                                    }else if(TeamInstanceId != null && s.Scenario_Stage__c != SalesIQGlobalConstants.LIVE && s.Employee_Assignment__c == true){
                                        validationFailedReason = Label.Scenario_Validation_Emp_Assignment_Enabled;
                                        break;
                                    }
                                    /*else if(employeeAssignment==true){
                                        List<Workspace__c>  wrkspcLi= [select Country__c, Workspace_End_Date__c, Workspace_Start_Date__c from Workspace__c where id =: workspaceId];
                                        Date wrkspcStrtDt = wrkspcLi[0].Workspace_Start_Date__c;
                                        Date wrkspcEndDt = wrkspcLi[0].Workspace_End_Date__c;
                                        string country = wrkspcLi[0].Country__c;
                                        list<Scenario__c> lstOveralpScenario =[select id, Employee_Assignment__c from Scenario__c where Country__c =: country and Team_Name__c =: teamName and Request_Process_Stage__c = : SalesIQGlobalConstants.READY and Employee_Assignment__c =true and ((Effective_Start_Date__c >=: wrkspcStrtDt and Effective_Start_Date__c <=: wrkspcEndDt) or (Effective_End_Date__c >=: wrkspcStrtDt and Effective_End_Date__c <=: wrkspcEndDt))];
                                        system.debug('lstOveralpScenario1'+lstOveralpScenario);
                                        if(lstOveralpScenario.size()>0){
                                            validationFailedReason = Label.Scenario_Validation_Overlap_Employee_Assignment;
                                        }
                                    }*/
                                }
                            }
                        }

                        else if(employeeAssignment==true){
                            List<Workspace__c>  wrkspcLi= [select Country__c, Workspace_End_Date__c, Workspace_Start_Date__c from Workspace__c where id =: workspaceId];
                            Date wrkspcStrtDt = wrkspcLi[0].Workspace_Start_Date__c;
                            Date wrkspcEndDt = wrkspcLi[0].Workspace_End_Date__c;
                            string country = wrkspcLi[0].Country__c;
                            list<Scenario__c> lstOveralpScenario =[select id, Employee_Assignment__c from Scenario__c where Country__c =: country and Team_Name__c =: teamName and Request_Process_Stage__c = : SalesIQGlobalConstants.READY and Employee_Assignment__c =true and ((Effective_Start_Date__c >=: wrkspcStrtDt and Effective_Start_Date__c <=: wrkspcEndDt) or (Effective_End_Date__c >=: wrkspcStrtDt and Effective_End_Date__c <=: wrkspcEndDt))];
                            system.debug('lstOveralpScenario1'+lstOveralpScenario);
                            if(lstOveralpScenario.size()>0){
                                validationFailedReason = Label.Scenario_Validation_Overlap_Employee_Assignment;
                                return validationFailedReason;
                            }
                            list<Scenario__c> lstExistEmpAssScenario =[select id, Employee_Assignment__c from Scenario__c where Country__c =: country and Team_Name__c =: teamName and Request_Process_Stage__c = : SalesIQGlobalConstants.READY and Employee_Assignment__c =true];
                            system.debug('lstExistEmpAssScenario'+lstExistEmpAssScenario);
                            if(lstExistEmpAssScenario.size()>0){
                                validationFailedReason = Label.Scenario_Validation_Already_Employee_Assignment;
                                return validationFailedReason;
                            }
                        }

                    }
                }
            }
           
            return validationFailedReason;
        } 
        catch(Exception e) 
        {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
    }

    @AuraEnabled
    public static List<String> getLocaleDateFormats() {
        return new List<String>{SalesIQUtility.getUserDateFormat(), SalesIQUtility.getUserDateTimeFormat()};
    }

    @AuraEnabled
    public static void logException(String message,String module) 
    {
        if(message.length() > 2000)
           message = message.substring(0,2000); 
        SalesIQLogger.logErrorMessage(message, module);
    }

    
    public static void saveOnCanvas(String templateId, String scenarioId){
        system.debug('templateId::'+templateId);
        CPGUtility.getBusinessRuleDetails(templateId,scenarioId);
    }

    //METHOD TO COPY BR TEMPLATE OF EXISTING LIVE SCENARIO 
    public static void copyExistingScenario(String newscenarioid,Boolean copyexistingscenarioflag,String selectedscenarioid){
        List <BusinessRule_Template_Details__c> defaultbusinessRulesDetailsList = new List<BusinessRule_Template_Details__c>();
        CPGUtility.createScenarioRuleInstance(defaultbusinessRulesDetailsList,'',newscenarioid,copyexistingscenarioflag,selectedscenarioid);
    }

    //Insert DataObject and Scenario DataObject MAp
    public static void saveOnDataObjectAndScenarioDataObjectMap(String dataSources,String scenarioId,String templateId, Boolean copyexistingscenarioflag){
        List<Id> listExternalDataSetIds = new List<Id>();
        List<Id> listSFDCScenarioDataSetIds = new List<Id>();

        Map<String,String> extenalSourceTableNameToDestinationTableName = new Map<String,String>();
        Map<String,String> extenalDataSetNameToFinalTableName = new Map<String,String>();

        Savepoint sp = Database.setSavepoint(); 
        try{
            List<Data_Object__c> tobeInsertedDataObjects = new List<Data_Object__c>();
            List<Scenario_Data_Object_Map__c> lstOfScenDataObject2 = new List<Scenario_Data_Object_Map__c>();
            system.debug('dataSources::'+dataSources);
            list<DataSourceWrapper> lstDataSrcWrapper = (list<DataSourceWrapper>)JSON.deserialize(dataSources,list<DataSourceWrapper>.class);
            system.debug('lstDataSrcWrapper::'+lstDataSrcWrapper);
            

            List<Data_Set_Rule_Map__c> lstDataSetRuleMap = [SELECT Id,Business_Rule_Template_Details__c,dataset_id__c,dataset_id__r.is_upstream__c, dataset_id__r.Name, dataset_id__r.Base_Data_Set__c, dataset_id__r.Parent_Data_Set__c FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__r.Scenario_Id__c =: ScenarioId AND ((ds_type__c='I' AND dataset_id__r.is_internal__c = false) or dataset_id__r.is_upstream__c = true)];

            //MAP OF RULE MAP IDS TO BASE DATA SET IDS
            Map<String,String> ruleMapIdTobaseDataSetId = new Map<String,String>();
            String upstreamDataSet ;
            for(Data_Set_Rule_Map__c ruleMap:lstDataSetRuleMap ){
                SYSTEM.DEBUG('dataset_id__r.Base_Data_Set__c : ' + ruleMap.dataset_id__r.Base_Data_Set__c+' dataset_id__c :'+ruleMap.dataset_id__c) ;
                if(copyexistingscenarioflag)
                    ruleMapIdTobaseDataSetId.put(ruleMap.dataset_id__r.Parent_Data_Set__c , ruleMap.dataset_id__c);
                else
                    ruleMapIdTobaseDataSetId.put(ruleMap.dataset_id__r.Base_Data_Set__c , ruleMap.dataset_id__c);

                if(ruleMap.dataset_id__r.is_upstream__c){
                    upstreamDataSet = ruleMap.dataset_id__c;
                }
            }

            List<String> externalDataSourceFileNames = new List<String>();
            for(DataSourceWrapper obj:lstDataSrcWrapper){
                Data_Object__c dObj = new Data_Object__c();
                dObj.dataset_id__c = ruleMapIdTobaseDataSetId.get(obj.dataSetId);
                dObj.data_name__c = obj.filePath;
                dObj.delimeter__c = ',';
                dObj.Name = obj.dataSetName;

                if(obj.filePath != null && obj.filePath != ''){
                    system.debug('obj.filePath '+obj.filePath );
                    externalDataSourceFileNames.add(obj.filePath);
                }
                tobeInsertedDataObjects.add(dObj);
                //GET FINAL TABLE NAME IN CASE OF EXISTING SCENARIO 
                if(copyexistingscenarioflag)
                    extenalDataSetNameToFinalTableName.put(obj.dataSetName,obj.tableDisplayName);
            }

            system.debug('extenalDataSetNameToFinalTableName');
            system.debug(extenalDataSetNameToFinalTableName);
            insert tobeInsertedDataObjects;
            Set<Id> insertDOIds = new Set<Id>();
           
            List<Id> dataObjectIds = new List<Id>();
            for(Data_Object__c  dataObject : tobeInsertedDataObjects) {
                dataObjectIds.add(dataObject.Id);
            }

            List<Data_Object__c> lstNewScenarioDataSources = new List<Data_Object__c>();
            lstNewScenarioDataSources = [ SELECT id, Name, Final_Table__c from Data_Object__c where id in :dataObjectIds ] ; 

            for(Data_Object__c obj:lstNewScenarioDataSources){
                if(extenalDataSetNameToFinalTableName.containsKey(obj.Name)){
                    extenalSourceTableNameToDestinationTableName.put(extenalDataSetNameToFinalTableName.get(obj.Name),obj.Final_Table__c);
                }
            }

             system.debug('externalDataSourceFileNames');
            system.debug(externalDataSourceFileNames);
            system.debug(externalDataSourceFileNames.isEmpty());
                       system.debug(extenalSourceTableNameToDestinationTableName);

            //EXTERNAL PYTHON DATA SERVICE SIQ 1022 
            if( externalDataSourceFileNames.isEmpty() && copyexistingscenarioflag) {
                for(String sourceTableName :extenalSourceTableNameToDestinationTableName.keySet()){
                    //SERVICE TO COPY EXISTING EXTERNAL DATA SOURCES IN POSTGRES
                    system.debug('CALL COPY TABLE');
                    system.debug(sourceTableName);
                    system.debug(extenalSourceTableNameToDestinationTableName);
                    copyExternalDataSourcesInPostgres(sourceTableName,extenalSourceTableNameToDestinationTableName.get(sourceTableName),scenarioId);
                }
                
            }else if(!dataObjectIds.isEmpty()){
                //COPY DATA INTO NEW EXTERNAL DATA SOURCES FROM FILENAME
                syncExternalDataSourceFileToPostgres(String.join(dataObjectIds, ','),scenarioId);
            }

            List<Scenario_Data_Object_Map__c> tobeInsertedScenarioDataObjectMap = new List<Scenario_Data_Object_Map__c>();
            
            for(Data_Object__c dObj:tobeInsertedDataObjects){
                Scenario_Data_Object_Map__c scenarioDataObj = new Scenario_Data_Object_Map__c();
                scenarioDataObj.Data_Object__c = dObj.Id;
                scenarioDataObj.Data_Set__c = dObj.dataset_id__c;
                scenarioDataObj.Scenario__c =ScenarioId;
                tobeInsertedScenarioDataObjectMap.add(scenarioDataObj);
            }

            if(upstreamDataSet != null) {
                Scenario_Data_Object_Map__c scenarioDataObj = new Scenario_Data_Object_Map__c();
                scenarioDataObj.Data_Set__c = upstreamDataSet;
                scenarioDataObj.Scenario__c = ScenarioId;
                tobeInsertedScenarioDataObjectMap.add(scenarioDataObj);
            }

            List<Data_Set_Rule_Map__c> lstOfDataSetIds = [SELECT dataset_id__c, dataset_id__r.Is_Master__c, dataset_id__r.Name FROM Data_Set_Rule_Map__c WHERE scenario_rule_instance_id__c = NULL AND dataset_id__r.is_internal__c = false AND dataset_id__r.SalesIQ_Internal__c = true AND Business_Rule_Template_Details__r.Business_Rule_Template_Id__c =:templateId];
            Set<Id> sDataSetIds = new Set<Id>();

            for(Data_Set_Rule_Map__c obj:lstOfDataSetIds){
                sDataSetIds.add(obj.dataset_id__c);
            }

            List<Data_Object__c> lstOfDataObjects = [SELECT Id,data_name__c,name,dataset_id__c FROM Data_Object__c WHERE dataset_id__c in: sDataSetIds];

            for(Data_Object__c dObj:lstOfDataObjects){
                Scenario_Data_Object_Map__c scenarioDataObj = new Scenario_Data_Object_Map__c();
                scenarioDataObj.Data_Object__c = dObj.Id;
                scenarioDataObj.Data_Set__c = dObj.dataset_id__c;
                scenarioDataObj.Scenario__c =ScenarioId;
                tobeInsertedScenarioDataObjectMap.add(scenarioDataObj);
            }

            system.debug('tobeInsertedScenarioDataObjectMap');
            system.debug(tobeInsertedScenarioDataObjectMap);
            insert tobeInsertedScenarioDataObjectMap;

            CPGUtility.udpateScenarioInstanceDSRuleMapTableNames(lstDataSetRuleMap,scenarioId);


        }catch(Exception ex){
            System.debug('exception-->'+ex.getStackTraceString()+'~^'+ex.getMessage());
            Database.rollback(sp);
        }
    }

    /*
    METHOD TO SYNC/COPY EXTERNAL DATA SOURCES IN COPY SCENARIO SIQ 1022
    Params :1 . Source Postgres Table Name of external data source (eg. customer metrics)
            2. Destination Table Name of external data source (eg. customer metrics)

    */
    @future (callout=true)
    public static void copyExternalDataSourcesInPostgres(String pgSourceTableName, String pgDestinationTableName,String scenarioId){
        try{

            String copyDataSourceService = CPGUtility.getBRMSConfigValues('BRCopyExisitingTable');
            ETL_Config__c etlObj = CPGUtility.getETLConfigByName(CPGConstants.talend_Instance);
            String db_name = etlObj.BR_PG_Database__c;
            String pg_username = etlObj.BR_PG_UserName__c;
            String pg_password = etlObj.BR_PG_Password__c;

            ////SSL CHANGES
            Map<String,String> urlParams = new Map<String,String>();
            urlParams.put('serviceUrl',copyDataSourceService);

            //String url = copyDataSourceService+'?'+'source_table_name='+pgSourceTableName+'&destination_table_name='+pgDestinationTableName+'&db_name='+db_name+'&pg_username='+pg_username+'&pg_password='+pg_password;

            urlParams.put('source_table_name',pgSourceTableName);
            urlParams.put('destination_table_name',pgDestinationTableName);
            urlParams.put('db_name',db_name);
            urlParams.put('pg_username',pg_username);
            urlParams.put('pg_password',pg_password);


            system.debug('urlParams>>>'+urlParams);

            //Http h = new Http();
            //// Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
            //HttpRequest req = new HttpRequest();
            //req.setEndpoint(url);
            //req.setMethod('GET');
            //req.setHeader('Content-Type', 'application/json');
            //req.setHeader('Accept','application/json');
            //req.setTimeout(120000);
            //// Send the request, and return a response
            //HttpResponse res = h.send(req);
            HttpResponse res = SalesiqUtility.getHTTPResponse(urlParams.get('serviceUrl'),urlParams,'POST',120000);

            System.debug('response: python--> ' + res.getBody());
            if(res.getstatusCode() != 200)
            {
              Scenario__c scenario = [Select id,Run_Response_Details__c,Rule_Execution_Status__c from Scenario__c where id=: scenarioId];
              scenario.Rule_Execution_Status__c = CPGConstants.ERROR;
              scenario.Run_Response_Details__c = System.Label.python_service_sync_error + res.getStatus();
              update scenario;
            }
        }
        catch(exception ex)
        {
            Scenario__c mySc = [Select id,Run_Response_Details__c,Rule_Execution_Status__c from Scenario__c where id=: scenarioId];
            mySc.Rule_Execution_Status__c = CPGConstants.ERROR;
            mySc.Run_Response_Details__c = System.Label.python_service_sync_error;
            update mySc;
            SalesIQLogger.logErrorMessage(ex.getStackTraceString(), SalesIQLogger.ALIGNMENT_UTILITY);
        }



    }
   
    /*
    METHOD TO INVOKE PYTHON SERVICE
    */
    @future (callout=true)
    public static void syncExternalDataSourceFileToPostgres(String dataObjectIds, String scenarioId){

        system.debug('dataObjectIds>>>'+dataObjectIds);
        try{
            ETL_Config__c etlObj = CPGUtility.getETLConfigByName(CPGConstants.talend_Instance);
            //String sf_UserName = etlObj.SF_UserName__c;
            //String sf_Passwd = etlObj.SF_Password__c;
            //String sf_SecurityToken = etlObj.S3_Security_Token__c;
            //String dbName = etlObj.BR_PG_Database__c;
            //String do_Id = dataObjectIds;
            String dataSourceService = CPGUtility.getBRMSConfigValues('BRDataSourceService');
            Map<String,String> dataServiceParams = new Map<String,String>();
            String isSandbox = ( SalesIQUtility.isSandboxOrg() ) ? 'true' : 'false';
            
            dataServiceParams.put('finalURL',dataSourceService);
            dataServiceParams.put('sf_username',etlObj.SF_UserName__c);
            dataServiceParams.put('sf_password',etlObj.SF_Password__c);
            dataServiceParams.put('sf_securitytoken',etlObj.S3_Security_Token__c);
            dataServiceParams.put('do_id',dataObjectIds);
            dataServiceParams.put('db_name',etlObj.BR_PG_Database__c);
            dataServiceParams.put('namespace',SalesIQGlobalConstants.NAME_SPACE);
            dataServiceParams.put('sandbox',isSandbox);

            HttpResponse res = SalesiqUtility.getHTTPResponse(dataServiceParams.get('finalURL'),dataServiceParams,'POST',120000);
        


            //SSL CHANGES
            //String url = dataSourceService+'?sf_username='+sf_UserName+'&sf_password='+etlObj.SF_Password__c+'&sf_securitytoken='+sf_SecurityToken+'&do_id='+do_Id+'&db_name='+dbName+'&namespace='+SalesIQGlobalConstants.NAME_SPACE+'&sandbox='+SalesIQUtility.isSandboxOrg(); 
            //system.debug('url>>>'+url);

            //Http h = new Http();
            //// Instantiate a new HTTP request, specify the method (GET) as well as the endpoint
            //HttpRequest req = new HttpRequest();
            //req.setEndpoint(url);
            //req.setMethod('GET');
            //req.setHeader('Content-Type', 'application/json');
            //req.setHeader('Accept','application/json');
            //req.setTimeout(120000);
            //// Send the request, and return a response
            //HttpResponse res = h.send(req);
            System.debug('response: python--> ' + res.getBody());
            if(res.getstatusCode() != 200)
            {
              Scenario__c mySc = [Select id,Run_Response_Details__c,Rule_Execution_Status__c from Scenario__c where id=: scenarioId];
              mySc.Rule_Execution_Status__c = CPGConstants.ERROR;
              mySc.Run_Response_Details__c = System.Label.python_service_sync_error + res.getStatus();
              update mySc;
              // return null;
            }
            String result = res.getBody();
        }
        catch(exception ex)
        {
            Scenario__c mySc = [Select id,Run_Response_Details__c,Rule_Execution_Status__c from Scenario__c where id=: scenarioId];
            mySc.Rule_Execution_Status__c = CPGConstants.ERROR;
            mySc.Run_Response_Details__c = System.Label.python_service_sync_error;
            update mySc;
            SalesIQLogger.logErrorMessage(ex.getStackTraceString(), SalesIQLogger.ALIGNMENT_UTILITY);
        }
    }


    /*
    Method to update the filter condition value in scenario data object map
    */

    public static void updateScenarioDataObjectMap(String ScenarioId)
    {
        try{
            List<Scenario_Data_Object_Map__c> scDataObjMapList = [Select id,Data_Set__c,Filter_Expression_Source__c,Filter_Expression_Destination__c,Data_Object_Filter_Expression_Source__c, Data_Object_Filter_Expression_Destn__c,Scenario__c,Data_Set__r.Column_Filter_Source__c,Data_Set__r.is_upstream__c, Data_Set__r.Column_Filter_Destination__c,Data_Set__r.Data_Filter_Value__c,Data_Set__r.Data_Filter_Operator__c from Scenario_Data_Object_Map__c where (Data_Set__r.SalesIQ_Internal__c = true or Data_Set__r.is_upstream__c = true) and Scenario__c =: ScenarioId];

            String ns = SalesIQGlobalConstants.NAME_SPACE;
            String filterQuery = 'select Id';
            Set<String> scenarioColumns = new Set<String>();

            for(Scenario_Data_Object_Map__c scDataMapObj : scDataObjMapList)
            {
                if(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c') != null)
                {
                    List<String> datafiltervalueCol = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c')).split(';');
                    for(String str : datafiltervalueCol)
                    {
                        if(str.indexOf('Scenario__c') != -1)
                        {
                            scenarioColumns.add(str.substring(str.indexOf('.')+1,str.length()).toLowerCase());
                        }
                    }
                    
                }
            } 
            system.debug('scenarioColumns---' + scenarioColumns);
            if(scenarioColumns.size() > 0)
                filterQuery = filterQuery + ',';
            filterQuery = filterQuery + String.join(new List<String>(scenarioColumns), ',') +  ' from '+ns+'Scenario__c where id=:ScenarioId';

            system.debug('Scenario query ---> ' +filterQuery);
            Scenario__c myScenario = Database.query(filterQuery);

            for(Scenario_Data_Object_Map__c scDataMapObj : scDataObjMapList)
            {
                if(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c') != null)
                {
                    String sourceValue = '';
                    String destinationValue = '';
                    String dataFilterOperator = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Operator__c'));
                    if(dataFilterOperator == null)
                    {
                        dataFilterOperator = '{0}';
                    }

                    List<String> datafiltervalueTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Data_Filter_Value__c')).split(';');
                    List<String> datafiltersourceTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Column_Filter_Source__c')).split(';');
                    List<String> datafilterdestinationTempList = String.valueOf(scDataMapObj.getSObject(ns+'Data_Set__r').get(ns+'Column_Filter_Destination__c')).split(';');   

                    /* ----------------- Code block by Aditi, for enhanced filter condition ----------------- */
                    List<String> filterFullSourceConditions = new List<String>();
                    List<String> filterFullDestinationConditions = new List<String>();
                    for(Integer j = 0;j<datafiltervalueTempList.size();j++)
                    {
                        String datafiltervalue = datafiltervalueTempList[j];
                        String sourceCondition = '', destinationCondition = '' ;
                        if(datafiltervalue.indexOf('Scenario__c') != -1) 
                        {
                            datafiltervalue = datafiltervalue.substring(datafiltervalue.indexOf('.')+1,datafiltervalue.length());
                            List<String> datafiltervalueList = datafiltervalue.split('\\.');
                    
                            SObject intermediateObject = myScenario;
                            String finalFieldName = datafiltervalueList[0] ;
                            integer i = 0;
                            while(i < datafiltervalueList.size() - 1)
                            {
                                if(i == 0)
                                {
                                    intermediateObject = myScenario.getSObject(datafiltervalueList[0]);
                                }
                                else
                                {
                                    intermediateObject = intermediateObject.getSObject(datafiltervalueList[i]);
                                }
                                i = i+1;
                                finalFieldName = datafiltervalueList[i];
                            }

                            system.debug('Field Name FINAL ::' + finalFieldName);
                            
                            sourceCondition = datafiltersourceTempList[j] + ' = ' + '\''+ string.valueOf(intermediateObject.get(finalFieldName)) +'\'';
                            destinationCondition = datafilterdestinationTempList[j] + ' = ' + '\''+ string.valueOf(intermediateObject.get(finalFieldName)) +'\'';
                            
                        } 
                        else 
                        {
                            sourceCondition = datafiltersourceTempList[j] + ' = ' + datafiltervalueTempList[j];
                            if(datafiltervalueTempList[j].indexOf('\'') == -1)
                                destinationCondition = 'LOWER(' + datafilterdestinationTempList[j] + ') = ' + '\''+datafiltervalueTempList[j].toLowerCase()+'\'';
                            else
                                destinationCondition = datafilterdestinationTempList[j] + ' = ' + datafiltervalueTempList[j];
                        }

                        if(sourceCondition != '')
                            filterFullSourceConditions.add(sourceCondition);
                        if(destinationCondition != '')
                            filterFullDestinationConditions.add(destinationCondition);
                    }

                    scDataMapObj.Filter_Expression_Source__c = String.format(dataFilterOperator, filterFullSourceConditions);
                    scDataMapObj.Filter_Expression_Destination__c = String.format(dataFilterOperator, filterFullDestinationConditions);
                    
                }
            }
            update scDataObjMapList;
        }
        catch(Exception ex)
        {
            CPGUtility.InsertErrorLog(ex.getMessage(),ex.getStackTraceString());
        }
    }

    /*Below method is use to get the list of Team instance by Base Team Instance.
    This will be used when creating new scenario user select overlay type team. That team must have Controlling Team. 
    So based on that Controlling Team, we need to fetch all team instance.

    */
    @AuraEnabled
    public static map<string,string> getTeamInstanceByBaseTeam(string teamId){
        try {
            map<String,String> options = new map<String,String>();
            set<id> setTeam = new set<id>();
            SecurityUtil.checkRead(Team__c.SObjectType, new list<string>{'Controlling_Team__c'}, false) ;
            for(Team__c team : [Select id,Controlling_Team__c from Team__c where id = :teamId ])
            {
                setTeam.add(team.Controlling_Team__c);
            }
            system.debug('setTeam '+setTeam);
            system.debug('teamId '+teamId);

            /*list<string> strDelete = new list<string>{SalesIQGlobalConstants.DELETE_IN_QUEUE,SalesIQGlobalConstants.DELETE_IN_PROGRESS,'Partial Delete'};*/

            list<string> validScenarios = SalesIQUtility.getValidScenarios();
            
            if(SecurityUtil.checkRead(Team_Instance__c.SObjectType, new list<string>{'scenario__c','Team__c'}, false) && SecurityUtil.checkRead(scenario__c.SObjectType, new list<string>{'Request_Process_Stage__c'}, false)){
                for(Team_Instance__c teamInst:[select id,name, scenario__r.name,scenario__c from Team_instance__C where Team__c in:setTeam and scenario__r.Request_Process_Stage__c in:validScenarios]){
                    options.put(teamInst.ID, teamInst.Name);
                }

            }
            
            system.debug('options '+options);

            return options;
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }
       
    }

    @AuraEnabled
    public static list<CR_Team_Instance_Config__c> getConvergesLevel(string scenarioId){
        try {
            system.debug('scenarioId '+scenarioId);

            SecurityUtil.checkRead(CR_Team_Instance_Config__c.SObjectType, new list<string>{'Configuration_Name__c','Configuration_Type__c'}, false) ;
            return ([select id,Configuration_Name__c from CR_Team_Instance_Config__c where Configuration_Type__c=: SalesIQGlobalConstants.HIERARCHY_CONFIG and Team_Instance__c=:scenarioId]);
     
        }catch(Exception e) {
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            throw ex;
        }

    }

    @AuraEnabled
    public static string validateScenarioService(string jobName){
        string statusCode = '';
        try{
            list<ETL_Config__c> lstETLInfo = ScenarioUtility.getETLConfigByName(SalesIQGlobalConstants.PYTHON_JOB);
            system.debug('lstETLInfo '+lstETLInfo);
            string endPoint = '';
            if(lstETLInfo!=null && lstETLInfo.size()> 0){
                for(ETL_Config__c config: lstETLInfo){
                    //FUserName = config.SF_UserName__c;
                    //SFPassword = config.SF_Password__c;
                    endPoint = config.End_Point__c;
                }
                Http h = new Http();
                HttpRequest request = new HttpRequest();
                //request.setEndPoint('https://salesiqservices.axtria.com/scenario_operations/operations?');
                request.setEndPoint(endPoint);
                request.setMethod('GET');
                request.setTimeout(12000);
                HttpResponse reponse = h.send(request);                
                statusCode  = string.valueOf(reponse.getStatusCode());
                

            }else{
                statusCode = SalesIQGlobalConstants.ERROR_CODE_107;

            }

        }catch(Exception e) {
            if(e.getMessage().contains('Remote site settings')){
                system.debug('in if condition');
                //successErrorMap.put('Error',System.Label.No_Remote_Site_Setting);
                statusCode = SalesIQGlobalConstants.ERROR_CODE_106;
            }
            else{
                statusCode = SalesIQGlobalConstants.ERROR_CODE_404;
            }
            String message = e.getTypeName() + ': ' + e.getMessage() + '\n\n' + e.getStackTraceString() ;
            AuraHandledException ex = new AuraHandledException(message);
            ex.setMessage(message);
            //throw ex;
        }

        return statusCode;

    }




   
}